import "./style.css";
import { computed as F, resolveComponent as E, createElementBlock as P, openBlock as b, Fragment as q, renderList as Q, withDirectives as W, normalizeClass as z, unref as m, createElementVNode as j, normalizeStyle as Z, createCommentVNode as I, createBlock as R, withModifiers as ee, renderSlot as ne, mergeProps as te, vShow as oe, ref as ae, reactive as H, withCtx as G, createVNode as V, toDisplayString as re, onActivated as se, onDeactivated as ie, watch as ce, nextTick as le } from "vue";
import { SvgButton as de, PluginPanel as ue } from "@opentiny/tiny-engine-common";
import { constants as ge } from "@opentiny/tiny-engine-utils";
import { useCanvas as S, useMaterial as pe, useLayout as X, useMessage as he } from "@opentiny/tiny-engine-meta-register";
import { extend as fe } from "@opentiny/vue-renderless/common/object";
import { typeOf as me } from "@opentiny/vue-renderless/common/type";
const J = (p, i) => {
  const u = p.__vccOpts || p;
  for (const [r, _] of i)
    u[r] = _;
  return u;
}, be = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], ve = {
  key: 0,
  class: "expand-icon"
}, ye = {
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(p, { emit: i }) {
    const u = p, r = (e) => {
      const { idKey: o, labelKey: s, childrenKey: a } = u, h = e[o], x = e[s], D = e[a], d = { id: h, label: x, rawData: e };
      return Array.isArray(D) && (d.children = D.map((M) => r(M))), d;
    }, _ = (e) => Array.isArray(e) ? e.map((o) => r(o)) : [], k = F(() => _(u.data)), f = () => {
      const e = ae({});
      return { collapseMap: e, setCollapse: (a, h) => {
        e.value[a] = h;
      }, switchCollapse: (a) => {
        e.value[a] = !e.value[a];
      } };
    }, { collapseMap: v, setCollapse: A, switchCollapse: L } = f(), y = (e, o, s = 0, a = !1) => {
      const { children: h, ...x } = e, D = (h || []).map((M) => y(M, e.id, s + 1, a || v.value[e.id])).flat(), d = {
        ...x,
        parentId: o,
        level: s,
        hasChildren: (h == null ? void 0 : h.length) > 0,
        collapsed: a
      };
      return D.forEach((M) => {
        M.parent || (M.parent = d);
      }), [d].concat(D);
    }, g = (e) => y({ children: e }, null, -1).slice(1), O = F(() => g(k.value)), B = i, Y = (e) => {
      B("click", e);
    }, U = (e) => {
      B("mouseenter", e);
    }, n = () => {
      const e = { dragged: null, hovering: null, position: "", borderClass: "", forbidInsert: !1 }, o = H({ ...e });
      return { draggingState: o, resetDraggingState: () => {
        Object.assign(o, e);
      } };
    }, { draggingState: t, resetDraggingState: l } = n(), c = (e, o) => {
      u.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), t.dragged = o, o.hasChildren && A(o.id, !0));
    }, C = (e) => {
      const o = e.currentTarget.getBoundingClientRect(), s = e.clientY - o.top, a = 8;
      return s <= a ? { position: "top", borderClass: "border-top" } : s >= o.height - a ? { position: "bottom", borderClass: "border-bottom" } : { position: "center", borderClass: "border-all" };
    }, N = (e, o) => {
      if (!u.draggable)
        return;
      const s = C(e);
      if (o.id === O.value[0].id && s.position !== "center") {
        e.preventDefault();
        return;
      }
      if (u.disallowDrop({ dragged: t.dragged, target: o, position: s.position })) {
        Object.assign(t, { ...s, hovering: o, forbidInsert: !0 });
        return;
      }
      e.preventDefault(), Object.assign(t, { ...s, hovering: o, forbidInsert: !1 });
    }, w = () => {
      if (!u.draggable || t.forbidInsert)
        return;
      const { dragged: e, hovering: o, position: s } = t;
      B("drop", { dragged: e, target: o, position: s });
    }, K = () => {
      l();
    }, T = (e) => {
      if (!u.draggable)
        return;
      const o = e.currentTarget.getBoundingClientRect(), s = 4;
      (e.clientX <= o.left + s || e.clientX >= o.right - s || e.clientY <= o.top + s || e.clientY >= o.bottom - s) && Object.assign(t, { hovering: null });
    };
    return (e, o) => {
      const s = E("svg-icon");
      return b(), P("div", {
        class: "draggable-tree",
        onDragleave: T
      }, [
        (b(!0), P(q, null, Q(O.value, (a) => {
          var h, x, D;
          return W((b(), P("div", {
            key: a.id,
            class: z([
              "tree-row",
              "flex-center",
              {
                active: p.active === a.id,
                dragging: ((h = m(t).hovering) == null ? void 0 : h.id) === a.id,
                "border-all": ((x = m(t).hovering) == null ? void 0 : x.id) === a.id && m(t).position === "center",
                forbid: m(t).forbidInsert
              }
            ]),
            draggable: p.draggable ? "true" : void 0,
            onClick: (d) => Y(a),
            onMouseenter: (d) => U(a),
            onDragstart: (d) => c(d, a),
            onDragover: (d) => N(d, a),
            onDragenter: (d) => N(d, a),
            onDrop: w,
            onDragend: K
          }, [
            j("div", {
              class: "content flex-center",
              style: Z({ paddingLeft: `${12 * a.level}px` })
            }, [
              a.hasChildren ? I("", !0) : (b(), P("span", ve)),
              a.hasChildren ? (b(), R(s, {
                key: 1,
                name: "dropdown",
                class: z(["expand-icon", { rotate: m(v)[a.id] }]),
                onClick: ee((d) => m(L)(a.id), ["stop"])
              }, null, 8, ["class", "onClick"])) : I("", !0),
              j("div", {
                class: z([
                  "slot-content",
                  "flex-center",
                  {
                    [m(t).borderClass]: ((D = m(t).hovering) == null ? void 0 : D.id) === a.id && m(t).position !== "center",
                    forbid: m(t).forbidInsert
                  }
                ])
              }, [
                ne(e.$slots, "content", te({ ref_for: !0 }, a), void 0, !0)
              ], 2)
            ], 4)
          ], 42, be)), [
            [oe, !a.collapsed]
          ]);
        }), 128))
      ], 32);
    };
  }
}, De = /* @__PURE__ */ J(ye, [["__scopeId", "data-v-d1a48e9b"]]), { PAGE_STATUS: $ } = ge, Ce = {
  components: {
    PluginPanel: ue,
    SvgButton: de,
    DraggableTree: De
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(p) {
    const { pageState: i } = S(), { getMaterial: u } = pe(), { PLUGIN_NAME: r } = X(), _ = F(() => {
      var n;
      return (n = p.fixedPanels) == null ? void 0 : n.includes(r.OutlineTree);
    }), k = (n) => {
      const t = (l) => (l.forEach((c) => {
        c.show = i.nodesStatus[c.id] !== !1, c.showEye = !c.show;
        const C = c.children;
        me(C) !== "array" ? delete c.children : c.children.length && t(c.children);
      }), l);
      return [{ ...t([fe(!0, {}, n)])[0], componentName: "body", id: "body" }];
    }, f = H({
      pageSchema: [],
      isLock: F(
        () => ![$.Occupy, $.Guest].includes(X().layoutState.pageStatus.state)
      )
    }), { subscribe: v, unsubscribe: A } = he();
    return se(() => {
      f.pageSchema = k(i.pageSchema), v({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: n }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (f.pageSchema = k(i.pageSchema));
        }
      });
    }), ie(() => {
      A({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), ce(
      () => i.currentSchema,
      () => {
        const { getSchema: n } = S();
        f.pageSchema = k(n());
      }
    ), {
      panelFixed: _,
      eyeOpen: (n) => i.nodesStatus[n] !== !1,
      showNode: (n) => {
        n.show = !n.show, i.nodesStatus[n.id] = n.show;
        const { getRenderer: t, clearSelect: l } = S().canvasApi.value;
        t().setCondition(n.id, n.show), l();
      },
      state: f,
      PLUGIN_NAME: r,
      pageState: i,
      getIconName: (n) => (u(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(),
      handleClickRow: (n) => {
        if (f.isLock)
          return;
        const { selectNode: t } = S().canvasApi.value;
        t(n.id, "clickTree");
      },
      handleMouseEnterRow: (n) => {
        if (f.isLock)
          return;
        const { hoverNode: t } = S().canvasApi.value;
        t(n.id);
      },
      disallowDrop: ({ dragged: n, target: t, position: l }) => {
        if (n.id === "body")
          return !0;
        const c = l === "center" ? t : t.parent;
        if (c.id === "body")
          return !1;
        const { getConfigure: C, allowInsert: N } = S().canvasApi.value;
        return !N(C(c.rawData.componentName), n.rawData);
      },
      handleDrop: ({ dragged: n, target: t, position: l }) => {
        if (n.id === t.id || l === "center" && t.rawData.children.some((w) => w.id === n.id))
          return;
        if (l !== "center") {
          const w = t.parent.rawData.children, K = w.findIndex((e) => e.id === t.id), T = w[l === "top" ? K - 1 : K + 1];
          if (n.id === (T == null ? void 0 : T.id))
            return;
        }
        const { insertNode: c, removeNode: C, selectNode: N } = S().canvasApi.value;
        C(n.id), c(
          { data: n.rawData, node: t.rawData, parent: t.parent.rawData },
          l === "center" ? "in" : l
        ), le(() => {
          N(n.id, "clickTree");
        });
      }
    };
  }
}, Se = { class: "row-content" };
function _e(p, i, u, r, _, k) {
  const f = E("svg-button"), v = E("svg-icon"), A = E("draggable-tree"), L = E("plugin-panel");
  return b(), R(L, {
    class: "outlinebox",
    title: "大纲树",
    onClose: i[1] || (i[1] = (y) => p.$emit("close"))
  }, {
    header: G(() => [
      V(f, {
        class: "item icon-sidebar",
        name: r.panelFixed ? "fixed-solid" : "fixed",
        tips: r.panelFixed ? "解除固定面板" : "固定面板",
        onClick: i[0] || (i[0] = (y) => p.$emit("fix-panel", r.PLUGIN_NAME.OutlineTree))
      }, null, 8, ["name", "tips"])
    ]),
    content: G(() => {
      var y;
      return [
        V(A, {
          "label-key": "componentName",
          data: r.state.pageSchema,
          draggable: !0,
          active: (y = r.pageState.currentSchema) == null ? void 0 : y.id,
          "disallow-drop": r.disallowDrop,
          class: "outline-tree",
          onClick: r.handleClickRow,
          onMouseenter: r.handleMouseEnterRow,
          onDrop: r.handleDrop
        }, {
          content: G((g) => [
            j("div", Se, [
              r.getIconName(g) ? (b(), R(v, {
                key: 0,
                name: r.getIconName(g)
              }, null, 8, ["name"])) : I("", !0),
              j("span", {
                class: z(["row-label", { "node-isblock": g.rawData.componentType === "Block" }])
              }, re(g.label), 3),
              g.id !== "body" ? (b(), P(q, { key: 1 }, [
                r.eyeOpen(g.id) ? (b(), R(v, {
                  key: 0,
                  name: "eye",
                  onMouseup: (O) => r.showNode(g.rawData)
                }, null, 8, ["onMouseup"])) : I("", !0),
                r.eyeOpen(g.id) ? I("", !0) : (b(), R(v, {
                  key: 1,
                  name: "eye-invisible",
                  onMouseup: (O) => r.showNode(g.rawData)
                }, null, 8, ["onMouseup"]))
              ], 64)) : I("", !0)
            ])
          ]),
          _: 1
        }, 8, ["data", "active", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
      ];
    }),
    _: 1
  });
}
const ke = /* @__PURE__ */ J(Ce, [["render", _e], ["__scopeId", "data-v-2b0ae062"]]), Ne = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, Ee = {
  ...Ne,
  entry: ke
};
export {
  Ee as default
};
